#ifndef MANDELBROTWIDGET_H
#define MANDELBROTWIDGET_H

#include <QPixmap>
#include <QWidget>
#include "render.h"

class MandelbrotWidget : public QWidget {
    Q_OBJECT

  public:
    MandelbrotWidget (QWidget *parent = 0);

  protected:
    void paintEvent (QPaintEvent *event);
    void resizeEvent (QResizeEvent *event);
    void keyPressEvent (QKeyEvent *event);
    void wheelEvent (QWheelEvent *event);
    void mousePressEvent (QMouseEvent *event);
    void mouseMoveEvent (QMouseEvent *event);
    void mouseReleaseEvent (QMouseEvent *event);

  private slots:
    void updatePixmap (const QImage &image, double scaleFactor);
    void zoom  (double zoomFactor);
    void wheel (double zoomFactor, const QPoint & pos);
    void saveImage (void);

  private:
    void scroll (int deltaX, int deltaY);

    Render thread;
    QPixmap pixmap;
    QPoint pixmapOffset;
    QPoint lastDragPos;
    double centerX;
    double centerY;
    double pixmapScale;
    double curScale;
};

#endif
